'''
Created on Jun 20, 2013

@author: pascale
'''
# -*- coding: utf-8 -*-
import numpy


class Cloud ():
    def __init__(self,cloud,pression):
        self.cloud=cloud
        self.pression=pression

        
    def computeCloudLine(self,cloud=None,pression=None,layers=None):
        """ compute a specific line to represent clouds """
        if cloud != None : 
            self.cloud=cloud
        else :
            cloud=self.cloud    
        if pression != None : 
            self.pression=pression
        else :
            pression=self.pression 
               
        if layers==None : 
            layers = self.computeLayers(self.pression)
        nlevels=pression.shape[0]
        nlayers=layers.shape[0]
        y=numpy.zeros(nlevels*2)
        x=numpy.zeros(nlevels*2)

        x[0]=0
        y[0]=pression[0]
        y[2]=pression[0]
        x[1]=cloud[0]
    
        for i in range(0,nlayers) :
            y[2*i+1]=pression[i]
            x[2*i+1]=cloud[i]
            y[2*i+2]=pression[i+1]
            x[2*i+2]=cloud[i]
        x[2*nlevels-1]=0
        y[2*nlevels-1]=pression[nlevels-1]
        self.xcloud=x
        self.ycloud=y
        return (x,y)
    
    def getCloud(self,x = None):
        """ compute cloud sur layers """
        if x == None : 
            x=self.xcloud
        else :
            self.xcloud=x    
        nlayers=x.shape[0]/2-1
        cloud=numpy.zeros(nlayers)
        for i in range(0,nlayers-1):
            cloud[i]=x[i*2+1]
        return cloud    
        
    def update(self,xcloud,ycloud)    :
        self.xcloud=xcloud
        self.ycloud=ycloud
        
    def computeLayers(self,pression=None):
        """ Compute the mean value of pression in a layer """
        if pression != None : self.pression=pression
        foo=numpy.empty(self.pression.shape[0]-1)
        for i in range(foo.shape[0]) :
            foo[i]=(self.pression[i+1]+self.pression[i])/2
        return foo      


if  __name__ == "__main__": 
    import matplotlib
    import rmodel
    import matplotlib.pyplot as plt
    print "version matplotlib :",matplotlib.__version__       
    p=rmodel.project.Project()
    #p.openProfile('../rttov_tests/cldaer101lev_allgas.H5',1) 
    p.openProfile('../rttov_tests/cldaer101lev_allgas.H5',1) 
    cloud=p.myProfile['STCO']
    pression=p.myProfile['P']
    myCloud=Cloud(cloud,pression)
    fig=plt.figure()  
    ax1=fig.add_subplot(111)
    ax1.set_yscale('log')
    ax1.set_ylim((pression[-1],100))  
    ax1.set_ylim((pression[-1],100))               
    ax1.set_yticks((100,200,300,500,1000))
    label=('100','200','300','500','1000')
    layers=myCloud.computeLayers()   
    ax1.set_yticklabels(label) 
    for i in range(0,layers.shape[0]-1) :
        ax1.axhline(y=pression[i])
    ax1.plot(cloud,layers ,'g')
    (x,y)=myCloud.computeCloudLine()
    ax1.plot(x,y ,'r')
    newx=myCloud.getCloud(x)
    ax1.plot(newx,layers,'r')
    print x
    print y
    plt.show()
    
    
  