'''
Created on Sep 18, 2012

@author: pascale
'''
# -*- coding: utf-8 -*-

import wx
import rmodel
import h5py
import rttov
import util 
import cloud
import locale
import wxmpl
import numpy
import matplotlib
import sys
import copy
import logging
itemColor={'Q':"red",'O3':"green",'CO2':"magenta",'CH4':"cyan",'CO':"yellow", 'N2O':"black","T":"blue",
              'INSO':"Coral",'WASO':"crimson",'SOOT':"chocolate",'SSAM':"yellow",'SSCM':"orange",'MINM':"black",
              'MIAM':"aqua",'MICM':"BlueViolet",'MITR':"brown",  'SUSO':"CadetBlue",'VOLA':"magenta",'VAPO':"green",'ASDU':"red",
              'STCO':"red", 'STMA':"green", 'CUCC':"magenta", 'CUCP':"cyan", 'CUMA':"yellow", 'CIRR':"blue",'CFRAC':"brown","CLW":"green"}

itemMarker={'Q':"_",'O3':"_",'CO2':"_",'CH4':"_",'CO':"_", 'N2O':"_","T":"_",
              'INSO':"+",'WASO':"+",'SOOT':"+",'SSAM':"+",'SSCM':"+",'MINM':"+",
              'MIAM':"+",'MICM':"+",'MITR':"+",  'SUSO':"+",'VOLA':"+",'VAPO':"+",'ASDU':"+",
              'STCO':"*", 'STMA':"*", 'CUCC':"*", 'CUCP':"*", 'CUMA':"*", 'CIRR':"*",'CFRAC':"*","CLW":"*"
              }
kindOfItem={'Q':"GASES",'O3':"GASES",'CO2':"GASES",'CH4':"GASES",'CO':"GASES", 'N2O':"GASES","T":"GASES",
              'INSO':"AEROSOLS",'WASO':"AEROSOLS",'SOOT':"AEROSOLS",'SSAM':"AEROSOLS",'SSCM':"AEROSOLS",'MINM':"AEROSOLS",
              'MIAM':"AEROSOLS",'MICM':"AEROSOLS",'MITR':"AEROSOLS",  'SUSO':"AEROSOLS",'VOLA':"AEROSOLS",'VAPO':"AEROSOLS",'ASDU':"AEROSOLS",
              'STCO':"CLOUDS", 'STMA':"CLOUDS", 'CUCC':"CLOUDS", 'CUCP':"CLOUDS", 'CUMA':"CLOUDS", 'CIRR':"CLOUDS",'CFRAC':"CLOUDS","CLW":"CLOUDS"
              }
#from matplotlib.backend_wxagg import FigureCanvasWxAgg as FigureCanvas
axesDef={"GASES":     {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         "AEROSOLS":  {"xlimits":(0.001,100000),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
         "CLOUDS":    {"xlimits":(0,1.8),"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
         'Q':   {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         'O3':  {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         'CO2': {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         'CH4': {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
         'CO':  {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
          'N2O': {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
          "T":   {"xlimits":None ,"xscale":"linear","ylimits":None,"yscale":"log"},
          'INSO':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"}, 
          'WASO':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'SOOT':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'SSAM':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'SSCM':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'MINM':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'MIAM':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'MICM':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'MITR':   {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'SUSO':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'VOLA':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'VAPO':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'ASDU':  {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'STCO':   {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'STMA':    {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CUCC':    {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CUCP':   {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CUMA':   {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CIRR':   {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
          'CFRAC':   {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
           "CLW":   {"xlimits":None,"xscale":"linear","ylimits":(1100,0.5),"yscale":"log"},
                 
         }

locale.setlocale(locale.LC_ALL, '')
#---------------------------------------------------------------------------

class Data(wxmpl.Channel):
    """ Class to keep data for the PlotItemPanel data """
    def __init__(self,x,y,theName="",theColor=None,theStyle=None,theMarker=None):
        wxmpl.Channel.__init__(self,name=theName,color=theColor,style=theStyle,marker=theMarker)
        self.x=x
        self.y=y
    def getX(self):
        return self.x
    def getY(self):
        return self.y
    def myUpdate(self,x,y):
        self.x=numpy.zeros(x.shape[0])+x
        self.y=numpy.zeros(y.shape[0])+y
        self.setChanged('True')
    
class PlotItemPanel(wxmpl.PlotPanel):
    """ plot on a PlotPanel one curve """
   
    def __init__(self,parent,value,pression,theName,liste_item=None,kind="GASES",xlegend="(mw/cm-1/ster/sq.m)/ppmv",layer=None,yInPressions=False,tskin=None):
        self.theName=theName
        self.theParent=parent
        self.xlegend=xlegend
        self.kind=kind
        self.yInPressions=yInPressions
        self.layer=layer
        self.pression=pression
        self.value=value
        self.myCloud=None
        self.tskin=[]
        self.ytskin=[]
        if tskin :
            self.tskin.append(tskin)
        wxmpl.PlotPanel.__init__(self,parent,-1,None,autoscaleUnzoom=False) 
        self.onInsert=True
        self.OnPlot()
        if self.theParent.GetParent().GetParent().edit :
            wxmpl.EVT_POINT(self,self.GetId(),self._on_point)
        self.valueHistory=[]
        self.valueHistoryRedo=[]
        
    def SetXlimits(self,theName=None,xmin=None,xmax=None):
        """ set x limits """   

        if axesDef[self.theName]["xlimits"] != None : self.axes.set_xlim(axesDef[self.theName]["xlimits"])
        #if axesDef[self.theName]["ylimits"] != None : self.axes.set_ylim(axesDef[self.theName]["ylimits"])
        self.axes.set_xscale(axesDef[self.theName]["xscale"])
        #self.axes.set_yscale(axesDef[self.theName]["yscale"])

          
    def Update(self):
        self.stripCharter.update()  
   
    def UpdateData(self,dataX):
        self.x=dataX
        self.data.setChanged(True)
        if self.kind != "CLOUDS" :
            self.data.myUpdate(self.x, self.y)
        else :
            (self.xcloud,self.ycloud)=self.myCloud.computeCloudLine(cloud=dataX)
            self.data.myUpdate(self.xcloud, self.ycloud)    
        self.stripCharter.update()
        
    def OnPlot(self):
        matplotlib.rc('xtick', labelsize=8) 
        matplotlib.rc('ytick', labelsize=8) 
        fig=self.get_figure()   
        self.axes=fig.gca() 
        self.x=self.value[::1]
        if self.yInPressions : 
            self.axes.set_yscale("log")  
            self.axes.set_yticks((0.00005,0.0001,0.0002,0.0005,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.5,1,2,5,10,25,50,100,200,300,500,1000))
            label=('5e-5','1e-4','2e-4','5e-4','1e-3','2e-3','5e-3','0.01','0.02','0.05','0.1','0.2','0.5','1','2','5','10','25','50','100','200','300','500','1000')
            for tick in self.axes.yaxis.get_major_ticks():
                tick.label.set_fontsize(10)
            self.axes.set_yticklabels(label) 
            self.axes.set_ylabel('pressure (hPa)') 
            self.axes.set_ylim((self.pression[-1]+150,self.pression[0]))
        else :
            self.axes.set_ylim(self.value.shape[0]+2,1)  
            self.axes.set_ylabel('level')   
        if self.kind == "GASES" :     
            if self.yInPressions : 
                self.y=self.pression[::1]
            else :    
                self.y=numpy.arange(1,self.value.shape[0]+1,1)               
        else : 
            if self.yInPressions : 
                self.y=self.layer[::1]
            else :  
                self.y=numpy.arange(1.5,self.value.shape[0]+1,1)
              
        if self.kind != "CLOUDS" :                       
            self.data=Data(self.x,self.y,theName=self.theName,theColor=itemColor[self.theName],theMarker=itemMarker[self.theName])
        else :
            self.myCloud=cloud.Cloud(self.x,self.pression)
            (self.xcloud,self.ycloud)=self.myCloud.computeCloudLine()
            self.data=Data(self.xcloud,self.ycloud,theName=self.theName,theColor=itemColor[self.theName],theMarker=itemMarker[self.theName])
            
        self.axes.set_xlabel(self.xlegend)
        formatter=self.axes.xaxis.get_major_formatter()
        formatter.set_powerlimits((-3,4))
        self.axes.xaxis.set_major_formatter(formatter)       


        self.axes.grid(True,axis='both') 
        
        self.stripCharter=wxmpl.StripCharter(self.axes)
        
        self.myChannelList=[]
        self.myChannelList.append(self.data)        
        
         
        if self.theName == "T":
            if len(self.tskin) > 0 :
                if self.yInPressions : 
                    self.ytskin.append(self.pression[-1]+50)
                else :
                    self.ytskin.append(self.value.shape[0]+1)    
                datatskin=Data(self.tskin,self.ytskin,theName='TSKIN',theColor="red",theMarker="*")
                self.myChannelList.append(datatskin)
         
        self.stripCharter.setChannels(self.myChannelList)       
        if wx.Platform == '__WXMAC__':  
            self.Update()       

      
    def UpdateAllGraphics(self):  
        """ update the left panel but this method is not clean it would be better to send an event"""
        aProfile=self.theParent.GetParent().GetParent().GetProfile()
        aProfile[self.theName]=self.x
        self.theParent.GetParent().GetParent().allGraphicsPages[self.kind].UpdateData(aProfile,self.theName)
        if self.theName == "T" :
            for kind in ("AEROSOLS","CLOUDS") :
                if self.theParent.GetParent().GetParent().allGraphicsPages.has_key(kind) : 
                    self.theParent.GetParent().GetParent().allGraphicsPages[kind].UpdateData(aProfile,self.theName)
        
class PlotItemPanelAll(wxmpl.PlotPanel):
    """ Plot all gas in the same graphic """

    def __init__(self,parent,theProfile,kind="GASES",layer=None,xlegendT=None,xlegend=None,yInPressions=False):
        self.myProfile=theProfile
        self.pression=self.myProfile['P']
        self.layer=layer
        self.layerlevel=numpy.arange(1.5,self.myProfile['T'].shape[0],1)
        wxmpl.PlotPanel.__init__(self,parent,-1,None)
        self.kind=kind
        self.yInPressions=yInPressions
        self.itemsList={}
        self.itemsList['GASES']=self.myProfile.gas_list
        self.itemsList['AEROSOLS']=self.myProfile.aerosol_list
        self.itemsList['CLOUDS']=self.myProfile.cloud_list
        self.labelx={}
        self.labelx[kind]= xlegend
        self.labelxT=xlegendT
        self.OnPlot()
        
    def OnPlot(self,theProfile=None):   

        matplotlib.rc('xtick', labelsize=8) 
        matplotlib.rc('ytick', labelsize=8) 
        if theProfile != None : self.myProfile=theProfile
                
        pression=self.myProfile['P']
        tskin=[]
        tskin.append(self.myProfile['SKIN']['T'])
        ytskin=[]
        
        fig=self.get_figure()   
        fig.clear()
        self.axes=fig.gca()  
        
        self.data={}
        self.stripCharter=wxmpl.StripCharter(self.axes,loc_legend="center right")  
                   
#        self.axesT=self.axes.twiny()
#        self.axesT.set_xlabel(self.myProfile['T_ATTRIBUTE']['UNITS'])          
#        
        if self.yInPressions : 
            ytskin.append(self.pression[-1]+50)
            self.axes.set_yscale("log")  
            self.axes.set_yticks((0.00005,0.0001,0.0002,0.0005,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.5,1,2,5,10,25,50,100,200,300,500,1000))
            label=('5e-5','1e-4','2e-4','5e-4','1e-3','2e-3','5e-3','0.01','0.02','0.05','0.1','0.2','0.5','1','2','5','10','25','50','100','200','300','500','1000')
            for tick in self.axes.yaxis.get_major_ticks():
                tick.label.set_fontsize(10)
            self.axes.set_yticklabels(label) 
            self.axes.set_ylabel('pressure (hPa)') 
            self.axes.set_ylim((self.pression[-1],self.pression[0]))
            if self.kind == 'GASES' :
                y=self.myProfile['P'][::1]
            else :
                y=self.layer[::1]   
            ytempe=self.myProfile['P'][::1]
        else :

            self.axes.set_ylabel('level')   
            y=numpy.arange(1,self.myProfile['T'].shape[0]+1,1)
            ytskin.append(self.myProfile['T'].shape[0]+1)        
            if self.kind != 'GASES' :
                y=self.layerlevel
            ytempe=numpy.arange(1,self.myProfile['T'].shape[0]+1,1)
            self.axes.set_ylim(self.myProfile['T'].shape[0]+2,1)
        
        if self.kind == "GASES" :
            self.axes.set_xlabel(self.myProfile['Q_ATTRIBUTE']['UNITS'])
            markerFlag=False
        else :
            markerFlag=True
        if self.kind == "AEROSOLS" :
            for aero in self.myProfile.aerosol_list :
                if self.myProfile[aero] != None and self.myProfile[aero+'_ATTRIBUTE']['UNITS'] != 'n/a':
                    self.axes.set_xlabel(self.myProfile[aero+'_ATTRIBUTE']['UNITS'])
                
        self.axesT=self.axes.twiny()
        self.axesT.set_xlabel(self.myProfile['T_ATTRIBUTE']['UNITS'])    
        # must redefine ylim for the level case
        if not self.yInPressions  : self.axes.set_ylim(self.myProfile['T'].shape[0]+2,1)  
        if self.yInPressions  : self.axes.set_ylim((self.pression[-1]+150,self.pression[0]))
        self.stripCharterT=wxmpl.StripCharter(self.axesT,loc_legend="upper right")
        
        self.myChannelList=[]
        self.myChannelListT=[]         
        
        self.axes.grid(True,axis='both')
       
             
        for item in self.itemsList[self.kind]:
            if self.myProfile[item] != None :
                x=self.myProfile[item][::1]
                if markerFlag : 
                     self.data[item]=Data(x,y,theName=item,theColor=itemColor[item],theMarker=itemMarker[item])
                else :
                    self.data[item]=Data(x,y,theName=item,theColor=itemColor[item]) 
                self.myChannelList.append(self.data[item])
                
        x=self.myProfile['T'][::1]
        self.data['T']=Data(x,ytempe,theName='T',theColor=itemColor['T'])  
        self.data['TSKIN']=Data(tskin,ytskin,theName='TSKIN',theColor="red",theMarker="*")
        self.myChannelListT.append(self.data['T'])    
        self.myChannelListT.append(self.data['TSKIN'])

        formatter=self.axes.xaxis.get_major_formatter()
        formatter.set_powerlimits((-3,4))
        self.axes.xaxis.set_major_formatter(formatter)
        
        formatter=self.axesT.xaxis.get_major_formatter()
        formatter.set_powerlimits((-3,4))
        self.axesT.xaxis.set_major_formatter(formatter)
        
        self.stripCharter.setChannels(self.myChannelList)
        self.stripCharterT.setChannels(self.myChannelListT)
        if wx.Platform == '__WXMAC__':  
            self.Update()       

    def Update(self):  
        self.stripCharter.update()
        self.stripCharterT.update()
        
    def UpdateData(self,profile,itemName):
        """ Update the data with the profile and update the graphic 
            this method can't be used if there is a modification in number of gas or number of layers
            use OnPlot in this case """ 
        self.myProfile=profile 
        if self.myProfile[itemName] != None :
            if self.kind != 'GASES'  and itemName != 'T' and itemName != "CFRAC" :
                self.data[itemName].myUpdate(self.myProfile[itemName],self.layer)
            else :   
                if itemName != "CFRAC" :  
                    self.data[itemName].myUpdate(self.myProfile[itemName],self.myProfile['P'])
        self.stripCharter.update()
        self.stripCharterT.update()
        
       
class MyNotebook(wx.Notebook):     
    """ MyNotebook Class inherits from Notebook 
        Bind the event EVT_NOTEBOOK_PAGE_CHANGED with Update method of the page """
    def __init__(self,parent,isRightPage=True):
        wx.Notebook.__init__(self, parent, id=wx.ID_ANY, style=
                             wx.BK_DEFAULT
                             )
        self.parent=parent  
        self.isRightPage=isRightPage   
        self.BindEvent()   
          
    def BindEvent(self):
        self.Bind(wx.EVT_NOTEBOOK_PAGE_CHANGED,self.OnPageChanged)

    def OnPageChanged(self,event):  
        sel = self.GetSelection()
        thePage=self.GetPage(sel)
        thePage.Update()
        if self.isRightPage :
            item=thePage.theName
            if self.GetParent().GetParent().edit :
                isMenuOnRemove=self.parent.GetParent().items["remove"].IsChecked()
                self.parent.GetParent().graphicPages[item].onInsert=not isMenuOnRemove
        
        event.Skip()     

class  KProfileView (util.GenericViewRadio):
    """ Profile window of the application """        
    helpTitle="Help Profile"
    helpMessage="""
    Select and visualize a component profile on the right panel
    Click left button to modify the profile.
    Click left and drag a zone to zoom in.
    Click right button to zoom out. 
    Apply your changes or save the profile 
    for the next run of RTTOV.              
        """
    
    def __init__(self, parent,profile,channel=1,baseProfile=None,edit=False,yInPressions=True,runNumber=1):
        self.edit=edit
        logging.debug( "profile" +str( profile['T'].shape))
        logging.debug("baseProfile" + str(baseProfile['T'].shape))
        self.myProfile=copy.deepcopy(profile)
        self.yInPressions=yInPressions
        if baseProfile != None :
            self.myProfile['P']=baseProfile['P']
            self._ComputeLayers(self.myProfile['P']) 
        else :
            self.yInPressions=False 

        self.my_list_cloud=[]
        for cloud in  self.myProfile.cloud_list :  self.my_list_cloud.append(cloud)
        self.my_list_cloud.append("CFRAC")
        self.my_list_cloud.append("CLW")
        util.GenericView.__init__(self, parent,  "PROFILE")
      
        sizer = wx.BoxSizer(wx.HORIZONTAL)
        self.SetSizer(sizer)
        self.CreateMenuBar()  
        if baseProfile != None :
            self.items["ypressions"].Enable(True)
            self.items["ypressions"].Check(True)
            self.items["ylevels"].Check(False)
        else :
            
            self.items["ypressions"].Enable(False)
            self.items["ypressions"].Check(False)
            self.items["ylevels"].Check(True)
        self.SetSize((1300, 700))
        self.SetMinSize((1100, 700))
        self.SetTitle("run "+str(runNumber)+' k profile channel '+str(channel)) 
        #self._ComputeLayers(self.myProfile['P'])
        # panel 1 notebook with all curves (GASES, AEROSOLS, CLOUDS)
        self.panel1 =wx.Panel(self, -1,style=wx.BORDER_SIMPLE)
        
        self.panel1.SetSize((200,500))
        sizer.Add(self.panel1,1,wx.EXPAND)
        # creation of notebook for the panel 1
        self.nb_all=MyNotebook(self.panel1,isRightPage=False)

        sizer1=wx.BoxSizer()
        sizer1.Add(self.nb_all,1,wx.EXPAND)
        self.panel1.SetSizer(sizer1)
        
        # panel 2 notebook with one curve 
        self.panel2 = wx.Panel(self, -1,style=wx.BORDER_SIMPLE)
        sizer.Add(self.panel2,1,wx.EXPAND)
        # creation of the notebook for the panel 2
        self.nb=MyNotebook(self.panel2  )
        self.axesDef=[]
        
        # creation des graphiques
        self.Plot(self.myProfile)
              
        # create a second sizer for the notebook
        sizer2=wx.BoxSizer()
        sizer2.Add(self.nb,1,wx.EXPAND)
        self.panel2.SetSizer(sizer2)
        self.sb = self.CreateStatusBar()
        self.sb.SetBackgroundColour('WHITE')
        txt = ''
        self.sb.SetStatusText(txt)
        self.Centre()
        self.Show(True) 
        
       
    def PlotLeft(self,profile=None):      
        # plot panel 1 with all gas
        self.allGraphicsPages={}
        self.allGraphicsPages['GASES']=PlotItemPanelAll(self.nb_all,self.myProfile,kind='GASES',yInPressions=self.yInPression)
        self.nb_all.AddPage(self.allGraphicsPages['GASES'],'GASES')
         
        
        if  self.myProfile.anyAerosol() :  
            self.allGraphicsPages['AEROSOLS']=PlotItemPanelAll(self.nb_all,self.myProfile,kind="AEROSOLS",layer=self.layer,yInPressions=self.yInPression)
            self.nb_all.AddPage(self.allGraphicsPages['AEROSOLS'],'AEROSOLS')
       
#        if  self.myProfile.anyCloud() :  
#            self.allGraphicsPages['CLOUDS']=PlotItemPanelAll(self.nb_all,self.myProfile,kind="CLOUDS",layer=self.layer)
#            self.nb_all.AddPage(self.allGraphicsPages['CLOUDS'],'CLOUD')
    
    def Plot(self,profile=None):
        if profile != None : 
            self.myProfile=profile 
            self._ComputeLayers(self.myProfile['P'])
        self.graphicPages={}     
        self.graphicPages['T']=PlotItemPanel(self.nb,self.myProfile['T'],self.myProfile['P'],theName='T',xlegend=self.myProfile['T_ATTRIBUTE']['UNITS'],yInPressions=self.yInPressions,tskin=self.myProfile['SKIN']['T'])   
        self.nb.AddPage(self.graphicPages['T'],'T')          
        
        for gas in self.myProfile.gas_list :
            if self.myProfile[gas] != None :
                self.graphicPages[gas]=PlotItemPanel(self.nb,self.myProfile[gas],self.myProfile['P'],theName=gas,xlegend=self.myProfile[gas+'_ATTRIBUTE']['UNITS'],yInPressions=self.yInPressions)   
                self.nb.AddPage(self.graphicPages[gas],gas)
                
        if  self.myProfile.anyAerosol() :       
            for aerosol in self.myProfile.aerosol_list :   
                if self.myProfile[aerosol] != None :
                    self.graphicPages[aerosol]=PlotItemPanel(self.nb,self.myProfile[aerosol],self.myProfile['P'],theName=aerosol,kind="AEROSOLS",xlegend=self.myProfile[aerosol+'_ATTRIBUTE']['UNITS'],layer=self.layer,yInPressions=self.yInPressions)   
                    self.nb.AddPage(self.graphicPages[aerosol],aerosol)
                    
#        if  self.myProfile.anyCloud() :       
#            for cloud in  self.my_list_cloud :   
#                if self.myProfile[cloud] != None :
#                    if cloud == "CFRAC" : 
#                        mylegend="CFRAC"
#                    else :
#                        mylegend=  "layer mean content (g/m3)" 
#                    self.graphicPages[cloud]=PlotItemPanel(self.nb,self.myProfile[cloud],self.myProfile['P'],theName=cloud,kind="CLOUDS",xlegend=mylegend,layer=self.layer)   
#                    self.nb.AddPage(self.graphicPages[cloud],cloud)
                     
       # delete empty graphicPages
        for key in self.graphicPages.keys() :
            if self.myProfile[key] == None :
                del self.graphicPages[key]
      
                        
        # plot panel 1 with all gas
        self.allGraphicsPages={}
        self.allGraphicsPages['GASES']=PlotItemPanelAll(self.nb_all,self.myProfile,kind='GASES',xlegendT=self.myProfile['T_ATTRIBUTE']['UNITS'],xlegend=self.myProfile['Q_ATTRIBUTE']['UNITS'],yInPressions=self.yInPressions)
        self.nb_all.AddPage(self.allGraphicsPages['GASES'],'GASES')
         
        
        if  self.myProfile.anyAerosol() :  
            self.allGraphicsPages['AEROSOLS']=PlotItemPanelAll(self.nb_all,self.myProfile,kind="AEROSOLS",layer=self.layer,xlegendT=self.myProfile['T_ATTRIBUTE']['UNITS'],yInPressions=self.yInPressions)
            self.nb_all.AddPage(self.allGraphicsPages['AEROSOLS'],'AEROSOLS')
       
#        if  self.myProfile.anyCloud() :  
#            self.allGraphicsPages['CLOUDS']=PlotItemPanelAll(self.nb_all,self.myProfile,kind="CLOUDS",layer=self.layer)
#            self.nb_all.AddPage(self.allGraphicsPages['CLOUDS'],'CLOUD')
    
    def _ComputeLayers(self,pression):
        """ Compute the mean value of pression in a layer """
        foo=numpy.empty(pression.shape[0]-1)
        for i in range(foo.shape[0]) :
            foo[i]=(pression[i+1]+pression[i])/2
        self.layer=foo      
    
    def _MakeBinding(self):
        """ set the trivial Binding for the View """
        # binding cancel button
     
        
             
    def RePlotAll(self,profile=None):
        """ Plot the 2 panels with (new) profile (delete everything before redraw) """
       
        if profile != None : 
            self.myProfile=profile 
            self._ComputeLayers(self.myProfile['P'])
        # remove all pages of the notebook 
        self.nb.DeleteAllPages()
        self.nb_all.DeleteAllPages()
        self.Plot()
        
    def RePlotAllLeftPanel(self,profile=None):
        """ Plot the 2 panels with (new) profile (delete everything before redraw) """
       
        if profile != None : 
            self.myProfile=profile 
            self._ComputeLayers(self.myProfile['P'])
        # remove all pages of the notebook         
        self.nb_all.DeleteAllPages()
        self.PlotLeft()
     
  
               
    def addRightPage(self,item):
        """ add an new item page  """
        kind=kindOfItem[item]
        if kind == "GASES" :
            myY=self.myProfile['P']
        else :
            myY=self.layer    
        self.graphicPages[item]=PlotItemPanel(self.nb,self.myProfile[item],self.myProfile['P'],theName=item,kind=kind,xlegend=self.myProfile[item+'_ATTRIBUTE']['UNITS'],layer=myY,yInPressions=self.yInPression)   
        self.nb.AddPage(self.graphicPages[item],item)
        if kind == "CLOUDS" :
            if not self.graphicPages.has_key('CFRAC') :
                item='CFRAC'
                self.graphicPages[item]=PlotItemPanel(self.nb,self.myProfile[item],self.myProfile['P'],theName=item,kind=kind,xlegend="CFRAC",layer=myY,yInPressions=self.yInPression)   
                self.nb.AddPage(self.graphicPages[item],item)
            if not self.graphicPages.has_key('CLW') and self.myProfile['CLW'] != None :
                item = "CLW"
                self.graphicPages[item]=PlotItemPanel(self.nb,self.myProfile[item],self.myProfile['P'],theName=item,kind=kind,xlegend="CLW",layer=myY,yInPressions=self.yInPression)   
                self.nb.AddPage(self.graphicPages[item],item)
                
    def replotLeftPage(self):
        """ replot the left panel """
        # TOFO ne marche pas
        self.RePlotAllLeftPanel() 
       

                     
    def OnClose(self,e):
        """ close the surface windows"""
        self.Close()    
    

    def OnMouseMove(self,e):
        """ print x y value of the left plot in the status bar  """
        pass


            
    def OnYPressions (self,e):
        self.yInPressions=True
        self.RePlotAll()
        
    def OnYLevels (self,e):
        self.yInPressions=False
        self.RePlotAll()
          
    def MenuData(self):
        """ define the data for the menu
        """
        return( ("&File", # File Menu
                  ('&Quit', 'Quit',self.OnQuit,"quit",True,False)),
                   ("&Edit",  # Edit Menu
                    ("Yaxis in pressure units","put y in pressure units",self.OnYPressions,"ypressions",False,True),
                    ("Yaxis in level units","put y in level unit",self.OnYLevels,"ylevels",True,True)),
               
                ("&Help",  # Help Menu
                  ("About","About screen",self.OnAbout,"about",True,False)) )
                 
                
       
if  __name__ == "__main__": 

    print "version matplotlib :",matplotlib.__version__       
    p=rmodel.project.Project()
    ex = wx.App()
    fh5 =sys.argv[1]
    print "f=",fh5
    kmat = rttov.kmatrix.Kmatrix()
    frad =  h5py.File(fh5, 'r')
    h5 = frad['/']
    kmat.loadh5(h5)
    baseProfile=rttov.profile.Profile()
    
    frad.close()
    baseProfile=rmodel.project.OpenAProfile(fh5, 1)
   
    profile = kmat.getchanprof(1)
    print "tskin" ,profile['SKIN']['T']
    
    profile.display()
    print "T shape" ,profile['T'].shape
    print " NLEVELS : ", profile['NLEVELS']
    print profile['NLEVELS']
    print "P"
    print baseProfile["P"]
    print "T"
    print profile['T']
    print max(profile['T'])
    
   # frame = KProfileView(None,profile,baseProfile=baseProfile,channel=1,yInPressions=True)
    frame = KProfileView(None,profile,channel=1,yInPressions=True,baseProfile=baseProfile)
    frame.Show()

    ex.MainLoop()
       
   
    print "loop" 
    ex.MainLoop()
    #ex.MainLoop()   
